Index: typo3/sysext/rtehtmlarea/extensions/Language/class.tx_rtehtmlarea_language.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/Language/class.tx_rtehtmlarea_language.php	(révision 6908)
+++ typo3/sysext/rtehtmlarea/extensions/Language/class.tx_rtehtmlarea_language.php	(copie de travail)
@@ -2,7 +2,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the Typo3 project. The Typo3 project is
@@ -85,10 +85,14 @@
 				$first = $GLOBALS['LANG']->getLL('No language mark');
 			}
 			$languages = array('none' => $first);
-			$languages = array_merge($languages, $this->getLanguages());
-			$languagesJSArray = 'HTMLArea.languageOptions = ' . json_encode(array_flip($languages));
+			$languages = array_flip(array_merge($languages, $this->getLanguages()));
+			$languagesJSArray = array();
+			foreach ($languages as $key => $value) {
+				$languagesJSArray[] = array($key, $value);
+			}
+			$languagesJSArray = 'var options = ' . json_encode($languagesJSArray) . ';';
 			$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'. $button .'.languagesUrl = "' . $this->htmlAreaRTE->writeTemporaryFile('', 'languages_'.$this->htmlAreaRTE->contentLanguageUid, 'js', $languagesJSArray) . '";';
+			RTEarea['.$RTEcounter.'].buttons.'. $button .'.dataUrl = "' . $this->htmlAreaRTE->writeTemporaryFile('', $button . '_' . $this->htmlAreaRTE->contentLanguageUid, 'js', $languagesJSArray) . '";';
 		}
 		return $registerRTEinJavascriptString;
 	}
Index: typo3/sysext/rtehtmlarea/extensions/SelectFont/class.tx_rtehtmlarea_selectfont.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/SelectFont/class.tx_rtehtmlarea_selectfont.php	(révision 6908)
+++ typo3/sysext/rtehtmlarea/extensions/SelectFont/class.tx_rtehtmlarea_selectfont.php	(copie de travail)
@@ -2,7 +2,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the Typo3 project. The Typo3 project is
@@ -133,13 +133,11 @@
 			// Initializing the items array
 		$items = array();
 		if ($this->htmlAreaRTE->is_FE()) {
-			$items['none'] = '
-			"' . $GLOBALS['TSFE']->getLLL((($buttonId == 'fontstyle') ? 'Default font' : 'Default size'), $this->LOCAL_LANG) . '" : ""';
+			$items['none'] = array($GLOBALS['TSFE']->getLLL((($buttonId == 'fontstyle') ? 'Default font' : 'Default size'), $this->LOCAL_LANG), 'none');
 		} else {
-			$items['none'] = '
-			"' . ($this->htmlAreaRTE->TCEform->inline->isAjaxCall
+			$items['none'] = array(($this->htmlAreaRTE->TCEform->inline->isAjaxCall
 					? $GLOBALS['LANG']->csConvObj->utf8_encode($GLOBALS['LANG']->getLL(($buttonId == 'fontstyle') ? 'Default font' : 'Default size'), $GLOBALS['LANG']->charSet)
-					: $GLOBALS['LANG']->getLL(($buttonId == 'fontstyle') ? 'Default font' : 'Default size')) . '" : ""';
+					: $GLOBALS['LANG']->getLL(($buttonId == 'fontstyle') ? 'Default font' : 'Default size')), 'none');
 		}
 			// Inserting and localizing default items
 		if ($hideItems != '*') {
@@ -155,8 +153,7 @@
 						}
 						$label = $this->htmlAreaRTE->TCEform->inline->isAjaxCall ? $GLOBALS['LANG']->csConvObj->utf8_encode($label, $GLOBALS['LANG']->charSet) : $label;
 					}
-					$items[$name] = '
-				"' . $label . '" : "' . $this->htmlAreaRTE->cleanList($value) . '"';
+					$items[$name] = array($label, $this->htmlAreaRTE->cleanList($value));
 				}
 				$index++;
 			}
@@ -168,35 +165,29 @@
 				if (in_array($name, $addItems)) {
 					$label = $this->htmlAreaRTE->getPageConfigLabel($conf['name'],0);
 					$label = (!$this->htmlAreaRTE->is_FE() && $this->htmlAreaRTE->TCEform->inline->isAjaxCall) ? $GLOBALS['LANG']->csConvObj->utf8_encode($label, $GLOBALS['LANG']->charSet) : $label;
-					$items[$name] = '
-				"' . $label . '" : "' . $this->htmlAreaRTE->cleanList($conf['value']) . '"';
+					$items[$name] = array($label, $this->htmlAreaRTE->cleanList($conf['value']));
 				}
 			}
 		}
 			// Seting default item
 		if ($this->thisConfig['buttons.'][$buttonId . '.']['defaultItem'] && $items[$this->thisConfig['buttons.'][$buttonId . '.']['defaultItem']]) {
-			$items['none'] = $items[$this->thisConfig['buttons.'][$buttonId . '.']['defaultItem']];
+			$items['none'] = array($items[$this->thisConfig['buttons.'][$buttonId . '.']['defaultItem']][0], 'none');
 			unset($items[$this->thisConfig['buttons.'][$buttonId . '.']['defaultItem']]);
 		}
 			// Setting the JS list of options
-		$JSOptions = '';
-		$index = 0;
+		$itemsJSArray = array();
 		foreach ($items as $option) {
-			$JSOptions .= ($index ? ',' : '') . $option;
-			$index++;
+			$itemsJSArray[] = $option;
 		}
-		$JSOptions = '{'
-			. $JSOptions . '
-		};';
-
+		$itemsJSArray = 'var options = ' . json_encode($itemsJSArray) . ';';
+		
 			// Adding to button JS configuration
 		if (!is_array( $this->thisConfig['buttons.']) || !is_array($this->thisConfig['buttons.'][$buttonId . '.'])) {
 			$configureRTEInJavascriptString .= '
 			RTEarea['.$RTEcounter.'].buttons.'. $buttonId .' = new Object();';
 		}
 		$configureRTEInJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'. $buttonId .'.options = '. $JSOptions;
-
+			RTEarea['.$RTEcounter.'].buttons.'. $buttonId . '.dataUrl = \'' . $this->htmlAreaRTE->writeTemporaryFile('', $buttonId . '_'. $this->htmlAreaRTE->contentLanguageUid, 'js', $itemsJSArray) . '\';';
 		return $configureRTEInJavascriptString;
 	}
 } // end of class
Index: typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php	(révision 6908)
+++ typo3/sysext/rtehtmlarea/extensions/TableOperations/class.tx_rtehtmlarea_tableoperations.php	(copie de travail)
@@ -111,18 +111,20 @@
 			$disabledFieldsets = strtolower(implode(',', $disabledFieldsets));
 
 				// Dialogue fieldsets removal configuration
-			$dialogues = array('table', 'tableproperties', 'rowproperties', 'columnproperties', 'cellproperties');
-			foreach ($dialogues as $dialogue) {
-				if (!is_array( $this->thisConfig['buttons.']) || !is_array( $this->thisConfig['buttons.'][$dialogue.'.'])) {
-					$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.' = new Object();
-			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets = "' . $disabledFieldsets . '";';
-				} else if ($this->thisConfig['buttons.'][$dialogue.'.']['removeFieldsets']) {
-					$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets += ",' . $disabledFieldsets . '";';
-				} else {
-					$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets = ",' . $disabledFieldsets . '";';
+			if ($disabledFieldsets) {
+				$dialogues = array('table', 'tableproperties', 'rowproperties', 'columnproperties', 'cellproperties');
+				foreach ($dialogues as $dialogue) {
+					if (!is_array( $this->thisConfig['buttons.']) || !is_array( $this->thisConfig['buttons.'][$dialogue.'.'])) {
+						$registerRTEinJavascriptString .= '
+				RTEarea['.$RTEcounter.'].buttons.'.$dialogue.' = new Object();
+				RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets = "' . $disabledFieldsets . '";';
+					} else if ($this->thisConfig['buttons.'][$dialogue.'.']['removeFieldsets']) {
+						$registerRTEinJavascriptString .= '
+				RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets += ",' . $disabledFieldsets . '";';
+					} else {
+						$registerRTEinJavascriptString .= '
+				RTEarea['.$RTEcounter.'].buttons.'.$dialogue.'.removeFieldsets = ",' . $disabledFieldsets . '";';
+					}
 				}
 			}
 
Index: typo3/sysext/rtehtmlarea/extensions/TextIndicator/class.tx_rtehtmlarea_textindicator.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TextIndicator/class.tx_rtehtmlarea_textindicator.php	(révision 0)
+++ typo3/sysext/rtehtmlarea/extensions/TextIndicator/class.tx_rtehtmlarea_textindicator.php	(révision 0)
@@ -0,0 +1,66 @@
+<?php
+/***************************************************************
+*  Copyright notice
+*
+*  (c) 2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  All rights reserved
+*
+*  This script is part of the Typo3 project. The Typo3 project is
+*  free software; you can redistribute it and/or modify
+*  it under the terms of the GNU General Public License as published by
+*  the Free Software Foundation; either version 2 of the License, or
+*  (at your option) any later version.
+*
+*  The GNU General Public License can be found at
+*  http://www.gnu.org/copyleft/gpl.html.
+*
+*  This script is distributed in the hope that it will be useful,
+*  but WITHOUT ANY WARRANTY; without even the implied warranty of
+*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+*  GNU General Public License for more details.
+*
+*  This copyright notice MUST APPEAR in all copies of the script!
+***************************************************************/
+/**
+ * Text Indicator plugin for htmlArea RTE
+ *
+ * @author Stanislas Rolland <typo3(arobas)sjbr.ca>
+ *
+ * TYPO3 SVN ID: $Id: class.tx_rtehtmlarea_textindicator.php 5489 2009-05-23 15:26:20Z ohader $
+ *
+ */
+require_once(t3lib_extMgm::extPath('rtehtmlarea').'class.tx_rtehtmlareaapi.php');
+
+class tx_rtehtmlarea_textindicator extends tx_rtehtmlareaapi {
+	protected $extensionKey = 'rtehtmlarea';	// The key of the extension that is extending htmlArea RTE
+	protected $pluginName = 'TextIndicator';	// The name of the plugin registered by the extension
+	protected $relativePathToLocallangFile = '';	// Path to this main locallang file of the extension relative to the extension dir.
+	protected $relativePathToSkin = 'extensions/TextIndicator/skin/htmlarea.css';		// Path to the skin (css) file relative to the extension dir.
+	protected $htmlAreaRTE;				// Reference to the invoking object
+	protected $thisConfig;				// Reference to RTE PageTSConfig
+	protected $toolbar;				// Reference to RTE toolbar array
+	protected $LOCAL_LANG; 				// Frontend language array
+	protected $pluginButtons = 'textindicator';
+	protected $convertToolbarForHtmlAreaArray = array (
+		'textindicator'	=> 'TextIndicator',
+		);
+	/**
+	 * Return JS configuration of the htmlArea plugins registered by the extension
+	 *
+	 * @param	integer		Relative id of the RTE editing area in the form
+	 *
+	 * @return string		JS configuration for registered plugins
+	 *
+	 * The returned string will be a set of JS instructions defining the configuration that will be provided to the plugin(s)
+	 * Each of the instructions should be of the form:
+	 * 	RTEarea['.$RTEcounter.']["buttons"]["button-id"]["property"] = "value";
+	 */
+	public function buildJavascriptConfiguration($RTEcounter) {
+		$registerRTEinJavascriptString = '';
+		return $registerRTEinJavascriptString;
+	}
+}
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rtehtmlarea/extensions/TextIndicator/class.tx_rtehtmlarea_textindicator.php']) {
+	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rtehtmlarea/extensions/TextIndicator/class.tx_rtehtmlarea_textindicator.php']);
+}
+?>
\ No newline at end of file
Index: typo3/sysext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php	(révision 6908)
+++ typo3/sysext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php	(copie de travail)
@@ -2,7 +2,7 @@
 /***************************************************************
 *  Copyright notice
 *
-*  (c) 2008-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2008-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the Typo3 project. The Typo3 project is
@@ -50,7 +50,7 @@
 		);
 
 	public function main($parentObject) {
-		return parent::main($parentObject) && $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['rtehtmlarea']['allowStyleAttribute'] && !$this->thisConfig['disableSelectColor'];
+		return parent::main($parentObject) && $GLOBALS['TYPO3_CONF_VARS']['EXTCONF']['rtehtmlarea']['allowStyleAttribute'];
 	}
 
 	/**
@@ -80,53 +80,40 @@
 	 * @return	string		Javascript configuration of colors
 	 */
 	function buildJSColorsConfig($RTEcounter) {
-
 		if ($this->htmlAreaRTE->is_FE()) {
 			$RTEProperties = $this->htmlAreaRTE->RTEsetup;
 		} else {
 			$RTEProperties = $this->htmlAreaRTE->RTEsetup['properties'];
 		}
-
 		$configureRTEInJavascriptString = '';
-
 		$configureRTEInJavascriptString .= '
 			RTEarea['.$RTEcounter.'].disableColorPicker = ' . (trim($this->thisConfig['disableColorPicker']) ? 'true' : 'false') . ';';
-
-			// Building JS array of configured colors
+			// Building the array of configured colors
 		if (is_array($RTEProperties['colors.']) )  {
 			$HTMLAreaColorname = array();
 			foreach ($RTEProperties['colors.'] as $colorName => $conf) {
-				$colorName=substr($colorName,0,-1);
-				$colorLabel = $this->htmlAreaRTE->getPageConfigLabel($conf['name']);
-				$HTMLAreaColorname[$colorName] = '
-				[' . $colorLabel . ' , "' . $conf['value'] . '"]';
+				$colorName = substr($colorName, 0, -1);
+				$colorLabel = $this->htmlAreaRTE->getPageConfigLabel($conf['name'], 0);
+				$colorLabel = (!$this->htmlAreaRTE->is_FE() && $this->htmlAreaRTE->TCEform->inline->isAjaxCall) ? $GLOBALS['LANG']->csConvObj->utf8_encode($colorLabel, $GLOBALS['LANG']->charSet) : $colorLabel;
+				$HTMLAreaColorname[$colorName] = array($colorLabel, strtoupper(substr($conf['value'], 1, 6)));
 			}
 		}
-
 			// Setting the list of colors if specified in the RTE config
-		if ($this->thisConfig['colors'] ) {
-			$HTMLAreaJSColors = '[';
+		if ($this->thisConfig['colors']) {
 			$HTMLAreaColors = t3lib_div::trimExplode(',' , $this->htmlAreaRTE->cleanList($this->thisConfig['colors']));
-			$HTMLAreaColorsIndex = 0;
+			$HTMLAreaJSColors = array();
 			foreach ($HTMLAreaColors as $colorName) {
-				if($HTMLAreaColorsIndex && $HTMLAreaColorname[$colorName]) {
-					$HTMLAreaJSColors .= ',';
+				if ($HTMLAreaColorname[$colorName]) {
+					$HTMLAreaJSColors[] = $HTMLAreaColorname[$colorName];
 				}
-				$HTMLAreaJSColors .= $HTMLAreaColorname[$colorName];
-				$HTMLAreaColorsIndex++;
 			}
-			$HTMLAreaJSColors .= '];';
 			$configureRTEInJavascriptString .= '
-			RTEarea['.$RTEcounter.'].colors = '. $HTMLAreaJSColors;
+			RTEarea['.$RTEcounter.'].colors = ' . json_encode($HTMLAreaJSColors) . ';';
 		}
-
 		return $configureRTEInJavascriptString;
 	}
-
-} // end of class
-
+}
 if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php']) {
 	include_once($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['ext/rtehtmlarea/extensions/TYPO3Color/class.tx_rtehtmlarea_typo3color.php']);
 }
-
 ?>
\ No newline at end of file
Index: typo3/sysext/rtehtmlarea/extensions/TYPO3Link/class.tx_rtehtmlarea_typo3link.php
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/TYPO3Link/class.tx_rtehtmlarea_typo3link.php	(révision 6908)
+++ typo3/sysext/rtehtmlarea/extensions/TYPO3Link/class.tx_rtehtmlarea_typo3link.php	(copie de travail)
@@ -87,10 +87,8 @@
 				$registerRTEinJavascriptString .= '
 			RTEarea['.$RTEcounter.'].buttons.'. $button .'.classesAnchorUrl = "' . $this->htmlAreaRTE->writeTemporaryFile('', 'classesAnchor_'.$this->htmlAreaRTE->contentLanguageUid, 'js', $this->buildJSClassesAnchorArray()) . '";';
 			}
-			if ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extensionKey]['plugins'][$this->pluginName]['additionalAttributes']) {
-				$registerRTEinJavascriptString .= '
-			RTEarea['.$RTEcounter.'].buttons.'. $button .'.additionalAttributes = "' . $GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extensionKey]['plugins'][$this->pluginName]['additionalAttributes'] .'";';
-			}
+			$registerRTEinJavascriptString .= '
+			RTEarea['.$RTEcounter.'].buttons.'. $button .'.additionalAttributes = "external' . ($GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extensionKey]['plugins'][$this->pluginName]['additionalAttributes'] ? (',' . $GLOBALS['TYPO3_CONF_VARS']['EXTCONF'][$this->extensionKey]['plugins'][$this->pluginName]['additionalAttributes']) : '') . '";';
 		}
 		return $registerRTEinJavascriptString;
 	}
Index: typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js	(révision 6908)
+++ typo3/sysext/rtehtmlarea/htmlarea/htmlarea-gecko.js	(copie de travail)
@@ -3,7 +3,7 @@
 *
 *  (c) 2002-2004 interactivetools.com, inc.
 *  (c) 2003-2004 dynarch.com
-*  (c) 2004-2009 Stanislas Rolland <typo3(arobas)sjbr.ca>
+*  (c) 2004-2010 Stanislas Rolland <typo3(arobas)sjbr.ca>
 *  All rights reserved
 *
 *  This script is part of the TYPO3 project. The TYPO3 project is
@@ -35,71 +35,24 @@
 /***************************************************
  *  GECKO-SPECIFIC FUNCTIONS
  ***************************************************/
-HTMLArea.prototype.isEditable = function() {
+HTMLArea.Editor.prototype.isEditable = function() {
 	return (this._doc.designMode === "on");
 };
-
 /***************************************************
- *  MOZILLA/FIREFOX EDIT MODE INITILIZATION
- ***************************************************/
-
-HTMLArea.prototype._initEditMode = function () {
-		// We can't set designMode when we are in a hidden TYPO3 tab
-		// Then we will set it when the tab comes in the front.
-	var isNested = false;
-	var allDisplayed = true;
-
-	if (this.nested.sorted && this.nested.sorted.length) {
-		isNested = true;
-		allDisplayed = HTMLArea.allElementsAreDisplayed(this.nested.sorted);
-	}
-	if (!isNested || allDisplayed) {
-		try {
-			this._iframe.style.display = "block";
-			this._doc.designMode = "on";
-			if (this._doc.queryCommandEnabled("insertbronreturn")) this._doc.execCommand("insertbronreturn", false, this.config.disableEnterParagraphs);
-			if (this._doc.queryCommandEnabled("enableObjectResizing")) this._doc.execCommand("enableObjectResizing", false, !this.config.disableObjectResizing);
-			if (this._doc.queryCommandEnabled("enableInlineTableEditing")) this._doc.execCommand("enableInlineTableEditing", false, (this.config.buttons.table && this.config.buttons.table.enableHandles) ? true : false);
-			if (this._doc.queryCommandEnabled("styleWithCSS")) this._doc.execCommand("styleWithCSS", false, this.config.useCSS);
-				else if (this._doc.queryCommandEnabled("useCSS")) this._doc.execCommand("useCSS", false, !this.config.useCSS);
-		} catch(e) {
-			if (HTMLArea.is_wamcom) {
-				this._doc.open();
-				this._doc.close();
-				this._initIframeTimer = window.setTimeout("HTMLArea.initIframe(\'" + this._editorNumber + "\');", 500);
-				return false;
-			}
-		}
-	}
-		// When the TYPO3 TCA feature div2tab is used, the editor iframe may become hidden with style.display = "none"
-		// This breaks the editor in Mozilla/Firefox browsers: the designMode attribute needs to be resetted after the style.display of the containing div is resetted to "block"
-		// Here we rely on TYPO3 naming conventions for the div id and class name
-	if (this.nested.sorted && this.nested.sorted.length) {
-		var nestedObj, listenerFunction;
-		for (var i=0, length=this.nested.sorted.length; i < length; i++) {
-			nestedObj = document.getElementById(this.nested.sorted[i]);
-			listenerFunction = HTMLArea.NestedListener(this, nestedObj, false);
-			HTMLArea._addEvent(nestedObj, 'DOMAttrModified', listenerFunction);
-		}
-	}
-	return true;
-};
-
-/***************************************************
  *  SELECTIONS AND RANGES
  ***************************************************/
 
 /*
  * Get the current selection object
  */
-HTMLArea.prototype._getSelection = function() {
+HTMLArea.Editor.prototype._getSelection = function() {
 	return this._iframe.contentWindow.getSelection();
 };
 
 /*
  * Empty the selection object
  */
-HTMLArea.prototype.emptySelection = function(selection) {
+HTMLArea.Editor.prototype.emptySelection = function(selection) {
 	if (HTMLArea.is_safari) {
 		selection.empty();
 	} else {
@@ -113,7 +66,7 @@
 /*
  * Add a range to the selection
  */
-HTMLArea.prototype.addRangeToSelection = function(selection, range) {
+HTMLArea.Editor.prototype.addRangeToSelection = function(selection, range) {
 	if (HTMLArea.is_safari) {
 		selection.setBaseAndExtent(range.startContainer, range.startOffset, range.endContainer, range.endOffset);
 	} else {
@@ -124,7 +77,7 @@
 /*
  * Create a range for the current selection
  */
-HTMLArea.prototype._createRange = function(sel) {
+HTMLArea.Editor.prototype._createRange = function(sel) {
 	if (HTMLArea.is_safari) {
 		var range = this._doc.createRange();
 		if (typeof(sel) == "undefined") {
@@ -143,7 +96,9 @@
 			return range;
 		}
 	}
-	if (typeof(sel) == "undefined") return this._doc.createRange();
+	if (Ext.isEmpty(sel)) {
+		return this._doc.createRange();
+	}
 	try {
 		return sel.getRangeAt(0);
 	} catch(e) {
@@ -154,7 +109,7 @@
 /*
  * Select a node AND the contents inside the node
  */
-HTMLArea.prototype.selectNode = function(node, endPoint) {
+HTMLArea.Editor.prototype.selectNode = function(node, endPoint) {
 	this.focusEditor();
 	var selection = this._getSelection();
 	var range = this._doc.createRange();
@@ -173,7 +128,7 @@
 /*
  * Select ONLY the contents inside the given node
  */
-HTMLArea.prototype.selectNodeContents = function(node, endPoint) {
+HTMLArea.Editor.prototype.selectNodeContents = function(node, endPoint) {
 	this.focusEditor();
 	var selection = this._getSelection();
 	var range = this._doc.createRange();
@@ -185,7 +140,7 @@
 	this.addRangeToSelection(selection, range);
 };
 
-HTMLArea.prototype.rangeIntersectsNode = function(range, node) {
+HTMLArea.Editor.prototype.rangeIntersectsNode = function(range, node) {
 	var nodeRange = this._doc.createRange();
 	try {
 		nodeRange.selectNode(node);
@@ -200,7 +155,7 @@
 /*
  * Get the selection type
  */
-HTMLArea.prototype.getSelectionType = function(selection) {
+HTMLArea.Editor.prototype.getSelectionType = function(selection) {
 		// By default set the type to "Text".
 	var type = "Text";
 	if (!selection) {
@@ -222,7 +177,7 @@
 /*
  * Retrieves the selected element (if any), just in the case that a single element (object like and image or a table) is selected.
  */
-HTMLArea.prototype.getSelectedElement = function(selection) {
+HTMLArea.Editor.prototype.getSelectedElement = function(selection) {
 	var selectedElement = null;
 	if (!selection) {
 		var selection = this._getSelection();
@@ -244,7 +199,7 @@
 /*
  * Retrieve the HTML contents of selected block
  */
-HTMLArea.prototype.getSelectedHTML = function() {
+HTMLArea.Editor.prototype.getSelectedHTML = function() {
 	var range = this._createRange(this._getSelection());
 	if (range.collapsed) return "";
 	var cloneContents = range.cloneContents();
@@ -257,14 +212,14 @@
 /*
  * Retrieve simply HTML contents of the selected block, IE ignoring control ranges
  */
-HTMLArea.prototype.getSelectedHTMLContents = function() {
+HTMLArea.Editor.prototype.getSelectedHTMLContents = function() {
 	return this.getSelectedHTML();
 };
 
 /*
  * Get the deepest node that contains both endpoints of the current selection.
  */
-HTMLArea.prototype.getParentElement = function(selection, range) {
+HTMLArea.Editor.prototype.getParentElement = function(selection, range) {
 	if (!selection) {
 		var selection = this._getSelection();
 	}
@@ -290,7 +245,7 @@
  * @returns null | element
  * Borrowed from Xinha (is not htmlArea) - http://xinha.gogo.co.nz/
  */
-HTMLArea.prototype._activeElement = function(selection) {
+HTMLArea.Editor.prototype._activeElement = function(selection) {
 	if (this._selectionEmpty(selection)) {
 		return null;
 	}
@@ -305,7 +260,7 @@
 /*
  * Determine if the current selection is empty or not.
  */
-HTMLArea.prototype._selectionEmpty = function(sel) {
+HTMLArea.Editor.prototype._selectionEmpty = function(sel) {
 	if (!sel) return true;
 	return sel.isCollapsed;
 };
@@ -317,7 +272,7 @@
  * in the range boundaries. The advantage of it is that it is possible to
  * handle DOM mutations when moving back to the bookmark.
  */
-HTMLArea.prototype.getBookmark = function (range) {
+HTMLArea.Editor.prototype.getBookmark = function (range) {
 		// Create the bookmark info (random IDs).
 	var bookmark = {
 		startId : (new Date()).valueOf() + Math.floor(Math.random()*1000) + 'S',
@@ -364,7 +319,7 @@
  * Get the end point of the bookmark
  * Adapted from FCKeditor
  */
-HTMLArea.prototype.getBookmarkNode = function(bookmark, endPoint) {
+HTMLArea.Editor.prototype.getBookmarkNode = function(bookmark, endPoint) {
 	if (endPoint) {
 		return this._doc.getElementById(bookmark.startId);
 	} else {
@@ -376,7 +331,7 @@
  * Move the range to the bookmark
  * Adapted from FCKeditor
  */
-HTMLArea.prototype.moveToBookmark = function (bookmark) {
+HTMLArea.Editor.prototype.moveToBookmark = function (bookmark) {
 	var startSpan  = this.getBookmarkNode(bookmark, true);
 	var endSpan    = this.getBookmarkNode(bookmark, false);
 
@@ -406,7 +361,7 @@
 /*
  * Select range
  */
-HTMLArea.prototype.selectRange = function (range) {
+HTMLArea.Editor.prototype.selectRange = function (range) {
 	var selection = this._getSelection();
 	this.emptySelection(selection);
 	this.addRangeToSelection(selection, range);
@@ -421,7 +376,7 @@
  * Delete the current selection, if any.
  * Split the text node, if needed.
  */
-HTMLArea.prototype.insertNodeAtSelection = function(toBeInserted) {
+HTMLArea.Editor.prototype.insertNodeAtSelection = function(toBeInserted) {
 	this.focusEditor();
 	var range = this._createRange(this._getSelection());
 	range.deleteContents();
@@ -434,7 +389,7 @@
  * Insert HTML source code at the current position.
  * Delete the current selection, if any.
  */
-HTMLArea.prototype.insertHTML = function(html) {
+HTMLArea.Editor.prototype.insertHTML = function(html) {
 	this.focusEditor();
 	var fragment = this._doc.createDocumentFragment();
 	var div = this._doc.createElement("div");
@@ -454,7 +409,7 @@
  *
  * @return	void
  */
-HTMLArea.prototype.wrapWithInlineElement = function(element, selection, range) {
+HTMLArea.Editor.prototype.wrapWithInlineElement = function(element, selection, range) {
 		// Sometimes Opera raises a bad boundary points error
 	if (HTMLArea.is_opera) {
 		try {
@@ -486,7 +441,7 @@
  *
  * @return	void
  */
-HTMLArea.prototype.cleanAppleStyleSpans = function(node) {
+HTMLArea.Editor.prototype.cleanAppleStyleSpans = function(node) {
 	if (HTMLArea.is_safari) {
 		if (node.getElementsByClassName) {
 			var spans = node.getElementsByClassName("Apple-style-span");
@@ -513,62 +468,10 @@
 /***************************************************
  *  EVENTS HANDLERS
  ***************************************************/
-
 /*
- * TYPO3 hidden tab and inline event listener (gets event calls)
- */
-HTMLArea.NestedListener = function (editor,nestedObj,noOpenCloseAction) {
-	return (function(ev) {
-		if(!ev) var ev = window.event;
-		HTMLArea.NestedHandler(ev,editor,nestedObj,noOpenCloseAction);
-	});
-};
-
-/*
- * TYPO3 hidden tab and inline event handler (performs actions on event calls)
- */
-HTMLArea.NestedHandler = function(ev,editor,nestedObj,noOpenCloseAction) {
-	window.setTimeout(function() {
-		var target = (ev.target) ? ev.target : ev.srcElement, styleEvent = true;
-			// In older versions of Mozilla ev.attrName is not yet set and refering to it causes a non-catchable crash
-			// We are assuming that this was fixed in Firefox 2.0.0.11
-		if (navigator.productSub > 20071127) {
-			styleEvent = (ev.attrName == "style");
-		}
-		if (target == nestedObj && editor.getMode() == "wysiwyg" && styleEvent && (target.style.display == "" || target.style.display == "block")) {
-				// Check if all affected nested elements are displayed (style.display!='none'):
-			if (HTMLArea.allElementsAreDisplayed(editor.nested.sorted)) {
-				window.setTimeout(function() {
-					try {
-						editor._doc.designMode = "on";
-						if (editor.config.sizeIncludesToolbar && editor._initialToolbarOffsetHeight != editor._toolbar.offsetHeight) {
-							editor.sizeIframe(2);
-						}
-						if (editor._doc.queryCommandEnabled("insertbronreturn")) editor._doc.execCommand("insertbronreturn", false, editor.config.disableEnterParagraphs);
-						if (editor._doc.queryCommandEnabled("enableObjectResizing")) editor._doc.execCommand("enableObjectResizing", false, !editor.config.disableObjectResizing);
-						if (editor._doc.queryCommandEnabled("enableInlineTableEditing")) editor._doc.execCommand("enableInlineTableEditing", false, (editor.config.buttons.table && editor.config.buttons.table.enableHandles) ? true : false);
-						if (editor._doc.queryCommandEnabled("styleWithCSS")) editor._doc.execCommand("styleWithCSS", false, editor.config.useCSS);
-							else if (editor._doc.queryCommandEnabled("useCSS")) editor._doc.execCommand("useCSS", false, !editor.config.useCSS);
-					} catch(e) {
-							// If an event of a parent tab ("nested tabs") is triggered, the following lines should not be
-							// processed, because this causes some trouble on all event handlers...
-						if (!noOpenCloseAction) {
-							editor._doc.open();
-							editor._doc.close();
-						}
-						editor.initIframe();
-					}
-				}, 50);
-			}
-			HTMLArea._stopEvent(ev);
-		}
-	}, 50);
-};
-
-/*
  * Backspace event handler
  */
-HTMLArea.prototype._checkBackspace = function() {
+HTMLArea.Editor.prototype._checkBackspace = function() {
 	if (!HTMLArea.is_safari && !HTMLArea.is_opera) {
 		var self = this;
 		window.setTimeout(function() {
@@ -609,7 +512,7 @@
 /*
  * Enter event handler
  */
-HTMLArea.prototype._checkInsertP = function() {
+HTMLArea.Editor.prototype._checkInsertP = function() {
 	var editor = this;
 	this.focusEditor();
 	var i, left, right, rangeClone,
@@ -742,7 +645,8 @@
  * Detect emails and urls as they are typed in Mozilla
  * Borrowed from Xinha (is not htmlArea) - http://xinha.gogo.co.nz/
  */
-HTMLArea.prototype._detectURL = function(ev) {
+HTMLArea.Editor.prototype._detectURL = function(event) {
+	var ev = event.browserEvent;
 	var editor = this;
 	var s = this._getSelection();
 	if (this.getParentElement(s).nodeName.toLowerCase() != 'a') {
@@ -754,7 +658,7 @@
 			a.appendChild(textNode);
 			rightText.data += " ";
 			s.collapse(rightText, rightText.data.length);
-			HTMLArea._stopEvent(ev);
+			event.stopEvent();
 	
 			editor._unLink = function() {
 				var t = a.firstChild;
@@ -809,7 +713,7 @@
 				if(ev.keyCode == 27 || (editor._unlinkOnUndo && ev.ctrlKey && ev.which == 122) ) {
 					if(this._unLink) {
 						this._unLink();
-						HTMLArea._stopEvent(ev);
+						event.stopEvent();
 					}
 					break;
 				} else if(ev.which || ev.keyCode == 8 || ev.keyCode == 46) {
